
#include "Flash.h"
#include <compiler_defs.h>
#include <C8051F380_defs.h>


void FLASH_ByteWrite (FLADDR addr, char byte)
{
	bit EA_SAVE = EA;                   // preserve EA
	char xdata * data pwrite;           // FLASH write pointer
	EA = 0;
	VDM0CN = 0x80;                      // enable VDD monitor
	RSTSRC = 0x02;                      // enable VDD monitor as a reset source
	pwrite = (char xdata *) addr;
	FLKEY  = 0xA5;                      // Key Sequence 1
	FLKEY  = 0xF1;                      // Key Sequence 2
	PSCTL |= 0x01;                      // PSWE = 1
	VDM0CN = 0x80;                      // enable VDD monitor
	RSTSRC = 0x02;                      // enable VDD monitor as a reset source
	*pwrite = byte;                     // write the byte
	PSCTL &= ~0x01;                     // PSWE = 0
	EA = EA_SAVE;                       // restore interrupts
}
//-----------------------------------------------------------------------------
// FLASH_ByteRead
//-----------------------------------------------------------------------------
//
// This routine reads a <byte> from the linear FLASH address <addr>.
//
unsigned char FLASH_ByteRead (FLADDR addr)
{
	bit EA_SAVE = EA;                   // preserve EA
	char code * data pread;             // FLASH read pointer
	unsigned char byte;
	EA = 0;                             // disable interrupts
	pread = (char code *) addr;
	byte = *pread;                      // read the byte
	EA = EA_SAVE;                       // restore interrupts
	return byte;
}
//-----------------------------------------------------------------------------
// FLASH_PageErase
//-----------------------------------------------------------------------------
//
// This routine erases the FLASH page containing the linear FLASH address
// <addr>.
//
void FLASH_PageErase (FLADDR addr)
{
 bit EA_SAVE = EA;                   // preserve EA
   char xdata * data pwrite;           // FLASH write pointer
   EA = 0;                          // disable interrupts
   VDM0CN = 0x80;                      // enable VDD monitorAN201
   RSTSRC = 0x02;                   // enable VDD monitor as a reset source
   pwrite = (char xdata *) addr;
   FLKEY  = 0xA5;                   // Key Sequence 1
   FLKEY  = 0xF1;                   // Key Sequence 2
   PSCTL |= 0x03;                   // PSWE = 1; PSEE = 1
   VDM0CN = 0x80;                      // enable VDD monitor
   RSTSRC = 0x02;                   // enable VDD monitor as a reset source
   *pwrite = 0;                     // initiate page erase
   PSCTL &= ~0x03;                  // PSWE = 0; PSEE = 0
   EA = EA_SAVE;                    // restore interrupts
}

