#include "compiler_defs.h"
#include "c8051f380_defs.h"
#include "Flash.h"
#include <stdio.h>
#include "SMBus.h"
#include <math.h>


#define true 1
#define false 0

#include "Font5x7.c"


#define ON 0
#define OFF 1

char bdata leds;
unsigned char led_brightness;

sbit GRNL = leds^0;
sbit YLWL = leds^1;
sbit REDL = leds^2;

sbit GRNR = leds^3;
sbit YLWR = leds^4;
sbit REDR = leds^5;

#define LEDS_MASK 0x3f


#define LEDS_OFF leds = 0x3f;

/*
#define GRNL leds[0]
#define YLWL leds[1]
#define REDL leds[2]
#define GRNR leds[3]
#define	YLWR leds[4]
#define REDR ldes[5]
*/

/*
sbit GRNL = P2^0;
sbit YLWL = P2^1;
sbit REDL = P2^2;

sbit GRNR = P2^3;
sbit YLWR = P2^4;
sbit REDR = P2^5;
*/


sbit SW0 = P3^0;
sbit SW1 = P3^1;
sbit SW2 = P3^2;

sbit CHIP_RST = P3^6;

char switch0;
char switch1;
char switch2;

int xdata SwitchTime0;
int xdata SwitchTime1;
int xdata SwitchTime2;
int xdata battery;
int xdata bcount;

char Display;

char xdata Preset;
char xdata edit;
int xdata faddr;
char dirty;
char shutdown;

struct PRESET {
	unsigned int center;	// highth of center of gravity
	unsigned int width;		// tack width or wheel base
	unsigned int warn;		// warning margin
	unsigned int alarm;		// alam margin
	float CA;
	char useCA;
} xdata presets[6];

char Alarm;
char Continuous;

char contrast;

char Str[22];


sbit ENA = P0^2;
sbit REG = P0^3;
sbit RnW = P0^4;
sbit RST = P0^5;
sbit CS0 = P0^6;  // left
sbit CS1 = P0^7;  // right

sbit LCDPWR = P2^7;


//int xdata X;
//int xdata Y;
//int xdata Z;
float xdata X;
float xdata Y;
float xdata Z;

int xdata motionX[2];		// previous state , difference
int xdata motionY[2];
int xdata motionZ[2];

int xdata motionless;


unsigned int jiffies;

char xdata LCD_Status;

unsigned char xdata fb[1024];

unsigned char code PageTable[8] = {0x1d, 0x9d, 0x5d, 0xdd, 0x3d, 0xbd, 0x7d, 0xfd};  // pages are bit reversed


unsigned char code Big0[64] = 	{	0x00, 0x01, 0x03, 0x07, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x07, 0x03, 0x01, 0x00,
							 	0xff, 0xff, 0xff, 0xff, 0xe0, 0xc0, 0x80, 0x00, 0x00, 0x80, 0xc0, 0xe0, 0xff, 0xff, 0xff, 0xff,
							 	0xff, 0xff, 0xff, 0xff, 0x07, 0x03, 0x01, 0x00, 0x00, 0x01, 0x03, 0x07, 0xff, 0xff, 0xff, 0xff,
								0x00, 0x80, 0xc0, 0xe0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xe0, 0xc0, 0x80, 0x00 };


unsigned char code Big1[64] = 	{	0x00, 0x00, 0x00, 0x01, 0x03, 0x07, 0x0f, 0x0f, 0x0f, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
							 	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
								0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
								0x00, 0x00, 0x00, 0x00, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0x00, 0x00, 0x00, 0x00 };

unsigned char code Big2[64] = 	{	0x00, 0x01, 0x03, 0x07, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x07, 0x03, 0x01, 0x00,
							 	0xf0, 0xf0, 0xf0, 0xf0, 0xe0, 0xc0, 0x80, 0x00, 0x01, 0x83, 0xc7, 0xef, 0xff, 0xfe, 0xfc, 0xf8,
							 	0x03, 0x07, 0x0f, 0x1f, 0x1f, 0x3e, 0x7c, 0xf8, 0xf0, 0xe0, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00,
								0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0 };

unsigned char code Big3[64] = 	{	0x01, 0x03, 0x07, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x07, 0x03, 0x01,
							 	0xf0, 0xf0, 0xe0, 0xc0, 0x80, 0x00, 0x03, 0x03, 0x03, 0x03, 0x83, 0xc7, 0xef, 0xff, 0xff, 0xfe,
							 	0x0f, 0x0f, 0x07, 0x03, 0x01, 0x00, 0xc0, 0xc0, 0xc0, 0xc0, 0xc1, 0xe3, 0xf7, 0xff, 0xff, 0x7f,
								0x80, 0xc0, 0xe0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xe0, 0xc0, 0x80 };

unsigned char code Big4[64] = 	{	0x0f, 0x0f, 0x0f, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x0f, 0x0f, 0x0f,
							 	0xff, 0xff, 0xff, 0xff, 0x07, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x07, 0xff, 0xff, 0xff, 0xff,
							 	0x80, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xe0, 0xff, 0xff, 0xff, 0xff,
								0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0xf0, 0xf0, 0xf0 };

unsigned char code Big5[64] = 	{	0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f,
							 	0xff, 0xff, 0xff, 0xff, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x03, 0x01, 0x00,
							 	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0xc1, 0xff, 0xff, 0xff, 0xff,
								0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xe0, 0xc0, 0x80 };

unsigned char code Big6[64] = 	{	0x01, 0x03, 0x07, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x00, 0x00,
							 	0xff, 0xff, 0xff, 0xff, 0x87, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x01, 0x00,
							 	0xff, 0xff, 0xff, 0xff, 0xe1, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xe1, 0xff, 0xff, 0xff, 0xff,
								0xc0, 0xe0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xe0, 0xc0 };

unsigned char code Big7[64] = 	{	0x00, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x00,
							 	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x03, 0xff, 0xff, 0xff, 0xfe, 0x00,
							 	0x00, 0x01, 0x03, 0x07, 0x0f, 0x1f, 0x3e, 0x7c, 0xf8, 0xf0, 0xe0, 0xc0, 0x80, 0x00, 0x00, 0x00,
								0x00, 0xf0, 0xf0, 0xf0, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };

unsigned char code Big8[64] = 	{	0x01, 0x03, 0x07, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x07, 0x03, 0x01,
							 	0xfe, 0xff, 0xff, 0xff, 0x87, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x87, 0xff, 0xff, 0xff, 0xfe,
							 	0x7f, 0xff, 0xff, 0xff, 0xe1, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xe1, 0xff, 0xff, 0xff, 0x7f,
								0xc0, 0xe0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xe0, 0xc0 };

unsigned char code Big9[64] = 	{	0x03, 0x07, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x07, 0x03,
							 	0xff, 0xff, 0xff, 0xff, 0x87, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x87, 0xff, 0xff, 0xff, 0xff,		
							 	0x00, 0x80, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xe1, 0xff, 0xff, 0xff, 0xff,
								0x00, 0x00, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xe0, 0xc0, 0x80 };


unsigned char code * BigNum[10] = {Big0, Big1, Big2, Big3, Big4, Big5, Big6, Big7, Big8, Big9};

unsigned char code CNTRST[8] = { 0x3c, 0x42, 0x81, 0x81, 0xff, 0xff, 0x7e, 0x3c };

// brightness tables  higher numbers are less bright for leds,   index higher for brigher ambient
unsigned char code LEDB[16] = {30, 30, 30, 30, 30, 30, 30, 29, 27, 23, 19, 15, 11, 7, 4, 0};
unsigned char code LCDB[16] = { 230, 230, 230, 230, 230, 200, 175, 128, 175, 230, 255, 255, 255, 255, 255, 255};


union VAL {
	int i;
	char c[4];
	float f;
} value;

int xdata Photo0;
int xdata Photo1;

float xdata slope;
int xdata CG;		// center of gravity
int xdata WB;		// wheel base
float xdata CA;	// critical angle in degrees
float xdata TiltAngle;
float xdata TiltMax;

float xdata lineX;
float xdata deltaX;
float xdata lineY;
float xdata deltaY[5];



unsigned char i;
unsigned char j;


#define ACCEL 0x3B
#define PHOTO 0x53

char ReadStatus(char side) {
char status;
	P1MDOUT   = 0;		// LCD Data BUS
	P1=0xFF;

	if (side) CS1=1;
	else CS0=1;

	REG = 0;
	RnW=1;
	ENA=0;
	ENA=1;
	ENA=1;
	ENA=1;
	status=P1;
	ENA=0;
	ENA=0;
	RnW=0;
    P1MDOUT   = 0xFF;	// LCD Data BUS
	CS0=0;
	CS1=0;
	return status;
}

void WritePage(char p){
char status;
// wait for status not busy on current chip select
	P1MDOUT   = 0;		// LCD Data BUS
	P1=0xFF;
	REG = 0;
	RnW=1;

	if (p&1) {	// select current chip
		CS0=0;
		CS1=1;
	} else {
		CS0=1;
		CS1=0;
	}

	do {
		ENA=0;
		ENA=1;
		ENA=1;
		ENA=1;
		status=P1;
		ENA=0;
		ENA=0;
	} while (status & 1);

	RnW=0;
    P1MDOUT   = 0xFF;	// LCD Data BUS

// write command to current chip
	P1= PageTable[p/2]; // start address 0
	REG=0;
	ENA=0;
	ENA=1;
	ENA=1;
	ENA=1;
	ENA=0;
	ENA=0;
	ENA=0;

}

void ResetColumn() {
char status;
// wait for status not busy on current chip select
	P1MDOUT   = 0;		// LCD Data BUS
	P1=0xFF;
	REG = 0;
	RnW=1;

	do {
		ENA=0;
		ENA=1;
		ENA=1;
		ENA=1;
		status=P1;
		ENA=0;
		ENA=0;
	} while (status & 1);

	RnW=0;
    P1MDOUT   = 0xFF;	// LCD Data BUS

// write command to current chip
	P1= 0x02; // start address 0
	REG=0;
	ENA=0;
	ENA=1;
	ENA=1;
	ENA=1;
	ENA=0;
	ENA=0;
	ENA=0;

}

int WriteRow(int fbx) {
int x;
char status;

	for (x=0; x<64; x++) {
// wait for status not busy on current chip select
		P1MDOUT   = 0;		// LCD Data BUS
		P1=0xFF;
		REG = 0;
		RnW=1;

		do {
			ENA=0;
			ENA=1;
			ENA=1;
			ENA=1;
			status=P1;
			ENA=0;
			ENA=0;
		} while (status & 1);

		RnW=0;
	    P1MDOUT   = 0xFF;	// LCD Data BUS

		P1= fb[fbx++]; // start address 0
		REG=1;
		ENA=0;
		ENA=1;
		ENA=1;
		ENA=1;
		ENA=0;
		ENA=0;
		ENA=0;
	}
	return fbx;
}

void SetPixel(char pix, float x, float y) {
	unsigned int xi;
	unsigned int yi;
	unsigned int dx;
	unsigned char pixels;

	xi = (int)(x + 0.5);
	yi = (int)(y + 0.5);
	if (xi>=128) return;
	if (yi>=64) return;
	dx = xi + (yi/8)*128;
	pixels = 0x80>>(yi%8);
	if (pix) fb[dx] |= pixels;
	else fb[dx] &= ~pixels;
	return;
}

void WriteFrame() {
char k;
int m;
	m=0;
	for (k=0;k<16; k++) { // pages
		WritePage(k);
		ResetColumn();
		m=WriteRow(m);
	}
	CS0=0;
	CS1=0;
}

void WriteBig(char page, char col, char * big) {
int m;
unsigned char l;

	m=((int)page<<7) + (int)col;

	for (l=0; l<16; l++) fb[m++]=big[l];
	m+=(int)112;
	for (l=16; l<32; l++) fb[m++]=big[l];
	m+=(int)112;
	for (l=32; l<48; l++) fb[m++]=big[l];
	m+=(int)112;
	for (l=48; l<64; l++) fb[m++]=big[l];


}

void WriteContrast(char page, char col) {
int m;
unsigned char l;
	m=((int)page<<7) + (int)col;
	for (l=0; l<8; l++) fb[m++]=CNTRST[l];
}

void WriteBigSpace(char page, char col) {
int m;
unsigned char l;

	m=((int)page<<7) + (int)col;

	for (l=0; l<16; l++) fb[m++]=0;
	m+=(int)112;
	for (l=16; l<32; l++) fb[m++]=0;
	m+=(int)112;
	for (l=32; l<48; l++) fb[m++]=0;
	m+=(int)112;
	for (l=48; l<64; l++) fb[m++]=0;

}

unsigned int WriteChar(char page, char col, char c) {
unsigned int fbx;
unsigned int cx;


		fbx = (unsigned int)col + ((unsigned int)page<<7);
		cx = (c - ' ')*5;
		fb[fbx++] = XP(Font5x7[cx++]);
		fb[fbx++] = XP(Font5x7[cx++]);
		fb[fbx++] = XP(Font5x7[cx++]);
		fb[fbx++] = XP(Font5x7[cx++]);
		fb[fbx++] = XP(Font5x7[cx++]);

		return ++fbx;

}

unsigned int WriteCharX(unsigned int fbx, char c) {

unsigned int cx;

		cx = (c - ' ')*5;
		fb[fbx++] = XP(Font5x7[cx++]);
		fb[fbx++] = XP(Font5x7[cx++]);
		fb[fbx++] = XP(Font5x7[cx++]);
		fb[fbx++] = XP(Font5x7[cx++]);
		fb[fbx++] = XP(Font5x7[cx++]);

		return ++fbx;
}


void WriteStr(char page, char col) {
unsigned int fbx;
char x;

		fbx=WriteChar(page, col, Str[0]);

		for (x=1; Str[x]  && (x<sizeof Str); x++) {
			fbx=WriteCharX(fbx, Str[x]);
		}
}


void Port_IO_Init()
{
	P4 = 0x9D; //0xBD;

	P3 = 0xBF;			// CHIP_RST low to prevent cycling of reset from power up

	P2 = 0xFF;
	P1 = 0xFF;
	P0 = 0xFF;

    P0MDOUT   = 0xFF;	// SCL and LCD controls
    P1MDOUT   = 0xFF;	// LCD Data BUS
    P2MDOUT   = 0x40;	// LEDS
    P3MDOUT   = 0x80;	// inputs
	P3 = 0xBF;			// CHIP_RST low to prevent cycling of reset from power up


    P4MDOUT   = 0x76;	//	P4.0 is NOT USED short to pin 23 for P3.7 in prototype
	P4MDIN    = 0x7F;
	P4 = 0x9D; //0xBD;

//	REDR=ON;


	while(!SDA)
   {
      // Provide clock pulses to allow the slave to advance out
      // of its current state. This will allow it to release SDA.
      XBR1 = 0x40;                     // Enable Crossbar
      SCL = 0;                         // Drive the clock low
      for(i = 0; i < 255; i++);        // Hold the clock low
      SCL = 1;                         // Release the clock
      while(!SCL);                     // Wait for open-drain
                                       // clock output to rise
      for(i = 0; i < 10; i++);         // Hold the clock high
      XBR1 = 0x00;                     // Disable Crossbar
   }

   P0SKIP = 0xfc;	// SMB on P0.0 and P0.1
   P1SKIP = 0xff;
   P2SKIP = 0xBf;	// CEX0 on P2.6
   P3SKIP = 0x7f;	// CEX1 on P3.7


   PCA0CPH0 = 128;		// 0.3% duty cycle  Vcontrast
   PCA0CPM0 = 0x42;		// 8 bit PWM mode

   PCA0CPH1 = 128;		// 50% duty cycle  LCD backlight
   PCA0CPM1 = 0x42;		// 8 bit PWM mode


   PCA0MD	= 0x88;		// disable while idle, use sysclk
   PCA0CN	= 0x40;		// run PCA


	XBR0      = 0x04;  // SMB 0
	XBR2	  = 0x00;
	XBR1      = 0xC2;	// Pullups are disabled  CEX0 for Vcontrast, CEX1 for Backlight

	ADC0CF = 0x38;		// set clock rate, right justified
	AMX0P  = 0x22;		// P4.7 for battery
	AMX0N  = 0x1f;		// GND
	REF0CN = 0x88;		// VDD 3.3 volts is reference
	ADC0CN = 0x80;

	P3 = 0xBF;			// CHIP_RST low to prevent cycling of reset from power up

	P2 = 0xFF;
	P1 = 0xFF;
	P0 = 0xFF;

    P0MDOUT   = 0xFF;	// SCL and LCD controls
    P1MDOUT   = 0xFF;	// LCD Data BUS
    P2MDOUT   = 0x40;	// LEDS
    P3MDOUT   = 0x80;	// inputs
	P3 = 0xBF;			// CHIP_RST low to prevent cycling of reset from power up

}

void Timer2_Init (void)
{
   TMR2CN = 0x00;                      	// Timer2 configured for 16-bit auto-
                                       	// reload, low-byte interrupt disabled
   CKCON &= ~0x20;                     	// Timer2 uses SYSCLK/12

   TMR2RL = -(SYSCLK/12/20000);         // Timer2 configured to overflow after
   TMR2 = TMR2RL;                      	// ~250us
 

   ET2=1;                       		// Timer2 interrupt enable
   TMR2CN |= 0x04;                     	// Start Timer2
}

void Timer2_ISR (void) interrupt 5
{
   TMR2CN &= ~0x80;                    // Clear Timer1 interrupt-pending
   jiffies++;
/*
   if((Alarm && ((jiffies & 0x1000) || Continuous )) || ((bcount&15)==0)) {
		
   		if ((jiffies &3)==0)  P4^=2;						// Alarm is active if true


   } else P4&=~2;
*/

	if (Alarm) {
		if (Continuous) {
			if ((jiffies &7)==0)  P4|=2;
			if ((jiffies &7)==3)  P4&=~2;
		} else {
			if (jiffies & 0x1000)
				if ((jiffies &7)==0)  P4|=2;
				if ((jiffies &7)==4)  P4&=~2;
		}
	} else P4&=~2;


	if ((jiffies & 31) > led_brightness)
   		P2=leds;
	else P2 |= LEDS_MASK;

}


// Initialization function for device,
// Call Init_Device() from your main program
void Init_Device(void)
{
	PCA0MD &= ~0x40;                    // WDTE = 0 (clear watchdog timer 
    PCA0MD =0;                          // enable)
	CLKSEL = 0x10;
 	OSCICN |= 0x03;                     // Configure internal oscillator for 12MHz

 	RSTSRC  &= ~0x04;                     // dissable missing clock detector
    Port_IO_Init();
	Timer1_Init ();                     // Configure Timer1 for use as SMBus
                                       // clock source

	Timer2_Init();

	Timer3_Init();                      // Configure Timer3 for use with SMBus
                                       // low timeout detect

	SMBus_Init ();                      // Configure and enable SMBus
	EIE1 |= 0x01;                       // Enable the SMBus interrupt


	switch0=0;
	switch1=0;
	switch2=0;

	SwitchTime0=0;
	SwitchTime1=0;
	SwitchTime2=0;


	EA = 1;

	Display=0;

}

unsigned int loops;
unsigned int dx;



void main() {


	Init_Device();
	loops=0;

// Initialize SMB devices
// Init of Photo Detector
	T0_Wait_ms(100);

	SMB_DATA_OUT[0] = 0x80;		// register
	SMB_DATA_OUT[1] = 0x01;		// active mode

	NUM_BYTES_WR =2;

	TARGET = PHOTO;             // Target the Slave for next SMBus
	                               // transfer
	SMB_Write();                     // Initiate SMBus write

	T0_Wait_ms(10);

	SMB_DATA_OUT[0] = 0x85;		// register
	SMB_DATA_OUT[1] = 0x12;		// data rate 200ms

	NUM_BYTES_WR =2;

	SMB_Write();                     // Initiate SMBus write



// Init of Accelerometer
	T0_Wait_ms(2);

	SMB_DATA_OUT[0] = 0x2a;		// register
	SMB_DATA_OUT[1] = 0x21;		// active mode, Data Rate 50Hz
	SMB_DATA_OUT[2] = 0x00;		// active mode, Data Rate 50Hz
	NUM_BYTES_WR =3;

	TARGET = ACCEL;             // Target the Slave for next SMBus
	                               // transfer
	SMB_Write();                     // Initiate SMBus write

	T0_Wait_ms(2);


	SMB_DATA_OUT[0] = 0x00;
	NUM_BYTES_WR = 1;					// register 0
	SMB_Write();                     // Initiate SMBus write

// Init LCD
	LCDPWR=ON;

	RST=0;
	CS0=0;
	CS1=0;
	RnW=0;
	ENA=0;
	REG=0;
	RST=1;

	T0_Wait_ms(5);

	while (ReadStatus(0) & 1);  // busy
	while (ReadStatus(1) & 1);  // busy

	P1= 0xfc;  // display enable bits are reversed
	CS0=1;
	ENA=1;
	ENA=1;
	ENA=1;
	ENA=1;
	ENA=0;
	ENA=0;
	CS0=0;

	CS1=1;
	ENA=1;
	ENA=1;
	ENA=1;
	ENA=1;
	ENA=0;
	ENA=0;
	CS1=0;


	while (ReadStatus(0) & 1);  // busy
	while (ReadStatus(1) & 1);  // busy


	P1= 0x02; // Y address 0
	CS0=1;
	ENA=1;
	ENA=1;
	ENA=1;
	ENA=1;
	ENA=0;
	ENA=0;
	CS0=0;

	CS1=1;
	ENA=0;

	ENA=1;
	ENA=1;
	ENA=1;
	ENA=1;
	ENA=0;
	CS1=0;

	while (ReadStatus(0) & 1);  // busy
	while (ReadStatus(1) & 1);  // busy


	P1= 0x1D; // page address 0
	CS0=1;
	ENA=0;
	ENA=1;
	ENA=1;
	ENA=1;
	ENA=1;

	ENA=0;
	CS0=0;

	CS1=1;
	ENA=1;
	ENA=1;
	ENA=1;
	ENA=1;

	ENA=0;
	CS1=0;

	while (ReadStatus(0) & 1);  // busy
	while (ReadStatus(1) & 1);  // busy

	P1= 0x03; // start address 0
	CS0=1;
	ENA=0;

	ENA=1;
	ENA=1;
	ENA=1;
	ENA=1;

	ENA=0;
	CS0=0;
	CS1=1;
	ENA=0;

	ENA=1;
	ENA=1;
	ENA=1;
	ENA=1;

	ENA=0;
	CS1=0;
	ENA=0;



	TiltAngle=0;
	TiltMax = 0;


	P4 = 0xdd; //0xFD;		// power up here to prevent start up reset ocsillation

// load saved states
	faddr =  0xf800;
	Preset = FLASH_ByteRead (faddr++);
	for (i=0; i<6; i++) {
		value.c[0] = FLASH_ByteRead (faddr++);
		value.c[1] = FLASH_ByteRead (faddr++);
		presets[i].center = value.i;

		value.c[0] = FLASH_ByteRead (faddr++);
		value.c[1] = FLASH_ByteRead (faddr++);
		presets[i].width = value.i;

		value.c[0] = FLASH_ByteRead (faddr++);
		value.c[1] = FLASH_ByteRead (faddr++);
		presets[i].warn = value.i;

		value.c[0] = FLASH_ByteRead (faddr++);
		value.c[1] = FLASH_ByteRead (faddr++);
		presets[i].alarm = value.i;

		value.c[0] = FLASH_ByteRead (faddr++);
		value.c[1] = FLASH_ByteRead (faddr++);
		value.c[2] = FLASH_ByteRead (faddr++);
		value.c[3] = FLASH_ByteRead (faddr++);
		presets[i].CA = value.f;

		value.c[0] = FLASH_ByteRead (faddr++);
		presets[i].useCA = value.c[0];


	}

	if ((Preset<0) || (Preset>=6) || (presets[5].useCA<0) ) {
		Preset=0;
		dirty=true;
		for (i=0; i<6; i++) {
			presets[i].center = 18;
			presets[i].width = 82;
			presets[i].warn = 20;
			presets[i].alarm = 10;
			presets[i].CA = 66.0;
			presets[i].useCA=false;
		}
	} else dirty = false;

	edit=0;
	deltaY[4]=0;
	deltaY[3]=0;
	deltaY[2]=0;
	deltaY[1]=0;
	deltaY[0]=0;

	motionless=0;

	led_brightness = 30;
	battery = 500;
	bcount = 1;
	shutdown = false;
	contrast = 0;
	Continuous=false;
	Alarm=false;

	Display=4; // warming screen
	SwitchTime0=-400;

while (1) {
	loops++;

	for (dx=0; dx<1024; dx++) {
		fb[dx]=0;
	}

    if (Display==0) {

		if (dirty) {
			dirty=false;
			faddr = 0xf800;
			FLASH_PageErase (faddr);	// use last page for states
			FLASH_ByteWrite (faddr++, Preset);
			for (i=0; i<6; i++) {
				value.i = presets[i].center;
				FLASH_ByteWrite (faddr++, value.c[0]);
				FLASH_ByteWrite (faddr++, value.c[1]);

				value.i = presets[i].width;
				FLASH_ByteWrite (faddr++, value.c[0]);
				FLASH_ByteWrite (faddr++, value.c[1]);

				value.i = presets[i].warn;
				FLASH_ByteWrite (faddr++, value.c[0]);
				FLASH_ByteWrite (faddr++, value.c[1]);

				value.i = presets[i].alarm;
				FLASH_ByteWrite (faddr++, value.c[0]);
				FLASH_ByteWrite (faddr++, value.c[1]);

				value.f = presets[i].CA;
				FLASH_ByteWrite (faddr++, value.c[0]);
				FLASH_ByteWrite (faddr++, value.c[1]);
				FLASH_ByteWrite (faddr++, value.c[2]);
				FLASH_ByteWrite (faddr++, value.c[3]);

				value.c[0] = presets[i].useCA;
				FLASH_ByteWrite (faddr++, value.c[0]);

			}
		}

		if (SW0) {
			if (SwitchTime0++ > 10)  {
				Display=1;
				SwitchTime0=-1000;
				motionless=0;
			}
			if (SwitchTime0== -991) Display=2;
		} else  {
			if (SwitchTime0>0) {  // short push
				TiltMax=0;
			}
			SwitchTime0=0;
		}

		if (SW1) {
			SwitchTime1++;
		} else SwitchTime1=0;

		if (SW2) {
			SwitchTime2++;
		} else SwitchTime2=0;


		if (SwitchTime2) {
			contrast++;
			if (SwitchTime2>2)  contrast+=5;
			if (contrast>100) contrast = 100;
		}

		if (SwitchTime1) {
			contrast--;
			if (SwitchTime1>2)  contrast-=5;
			if (contrast<-100) contrast = -100;
		}

		PCA0CPH0 = 110 + contrast;

		WriteChar(0, 78, 'o');


		slope = X/Y;
		if (slope> 10.0) slope=10.0;
		if (slope< -10.0) slope=-10.0;

		deltaX = 1.0;
		deltaY[4] += (deltaY[3]-deltaY[4]) * 0.5;
		deltaY[3] += (deltaY[2]-deltaY[3]) * 0.5;
		deltaY[2] += (deltaY[1]-deltaY[2]) * 0.5;
		deltaY[1] += (deltaY[0]-deltaY[1]) * 0.5;

		deltaY[0] += (slope  - deltaY[0]) * 0.5;

		for (j=0; j<5; j+=2) {
			lineX =64.0;
			lineY =40.0;

			for (i=0; i<64; i++) {
				SetPixel(1, lineX, lineY);
				lineX+=deltaX;
				lineY+=deltaY[j];
			}

			lineX =64.0;
			lineY =40.0;

			for (i=0; i<64; i++) {
				SetPixel(1, lineX, lineY);
				lineX-=deltaX;
				lineY-=deltaY[j];
			}
		}

		lineX =64.0;
		lineY =41.0;

		for (i=0; i<64; i++) {
			SetPixel(1, lineX, lineY);
			lineX+=deltaX;
			lineY+=deltaY[0];
		}

		lineX =64.0;
		lineY =41.0;

		for (i=0; i<64; i++) {
			SetPixel(1, lineX, lineY);
			lineX-=deltaX;
			lineY-=deltaY[0];
		}


		sprintf(Str, "%3.0f", TiltAngle);

		i = Str[1]-'0';
		if ((i>=0) && (i<10)) WriteBig(0,40,BigNum[i]);
		else WriteBigSpace(0,40);

		i = Str[2]-'0';
		if ((i>=0) && (i<10)) WriteBig(0,60,BigNum[i]);
		else WriteBigSpace(0,60);

		sprintf(Str, "Max=%2.0f", TiltMax);
		WriteStr(7, 40);

		sprintf(Str, "#%1d", (unsigned int)(Preset+1));
		WriteStr(7, 0);

		WriteContrast(7, 108);

		if (battery<305) bcount++;
		else bcount=1;
		
		if (bcount>5) {
			sprintf(Str, "LOW BATTERY");
			WriteStr(6, 30);

		}


	} // Display == 0;
	else if (Display==1) {

		if (SW0) {
			if (SwitchTime0++ > 30)  {
				Display=0;
				SwitchTime0=-1000;
			}
			if (SwitchTime0== -971) Display=2;
		} else  {
			if (SwitchTime0>0) {  // short push
				edit++;
				if (edit>5) edit=0;
			}
			SwitchTime0=0;
		}

		if (SW1) {
			SwitchTime1++;
		} else SwitchTime1=0;

		if (SW2) {
			SwitchTime2++;
		} else SwitchTime2=0;

		if (SwitchTime2==2  && !SwitchTime1) {
			dirty=true;
			switch (edit) {
				case 0:
					Preset++;  // 5 max
					if (Preset>5) Preset=0;
					break;

				case 1:
					presets[Preset].CA++;
					if (presets[Preset].CA>90.0) presets[Preset].CA = 90.0;
					presets[Preset].useCA=true;
					break;

				case 2:
					presets[Preset].center++;
					if (presets[Preset].center>999) presets[Preset].center = 999;
					presets[Preset].useCA=false;
					break;

				case 3:
					presets[Preset].width++;
					if (presets[Preset].width>999) presets[Preset].width=999;
					presets[Preset].useCA=false;
					break;

				case 4:
					presets[Preset].warn++;
					if (presets[Preset].warn>89) presets[Preset].warn=89;
					break;

				case 5:
				 	presets[Preset].alarm++;
					if (presets[Preset].alarm>89) presets[Preset].alarm=89 ;
					break;
			}
		}

		if (SwitchTime1==2  && !SwitchTime2) {
			dirty=true;
			switch (edit) {
				case 0:
					Preset--;  // 5 max
					if (Preset<0) Preset=5;
					break;

				case 1:
					presets[Preset].CA--;
					if (presets[Preset].CA<1.0) presets[Preset].CA = 1.0;
					presets[Preset].useCA=true;
					break;

				case 2:
					presets[Preset].center--;
					if (presets[Preset].center<1) presets[Preset].center = 1;
					presets[Preset].useCA=false;
					break;

				case 3:
					presets[Preset].width--;
					if (presets[Preset].width<10) presets[Preset].width=10;
					presets[Preset].useCA=false;
					break;

				case 4:
					presets[Preset].warn--;
					if (presets[Preset].warn<0) presets[Preset].warn=0;
					break;

				case 5:
				 	presets[Preset].alarm--;
					if (presets[Preset].alarm<0) presets[Preset].alarm=0; 
					break;
			}
		}

		if (SwitchTime2>20  && !SwitchTime1) {
			switch (edit) {
				case 0:
					Preset++;  // 5 max
					if (Preset>5) Preset=0;
					break;

				case 1:
					presets[Preset].CA++;
					if (SwitchTime2>60) presets[Preset].CA+=2.0;
					if (presets[Preset].CA>90.0) presets[Preset].CA = 90.0;
					presets[Preset].useCA=true;
					break;

				case 2:
					presets[Preset].center++;
					if (SwitchTime2>60) presets[Preset].center+=5;
					if (presets[Preset].center>999) presets[Preset].center = 999;
					presets[Preset].useCA=false;
					break;

				case 3:
					presets[Preset].width++;
					if (SwitchTime2>60) presets[Preset].width+=5;
					if (presets[Preset].width>999) presets[Preset].width=999;
					presets[Preset].useCA=false;
					break;

				case 4:
					presets[Preset].warn++;
					if (presets[Preset].warn>89) presets[Preset].warn=89;
					break;

				case 5:
				 	presets[Preset].alarm++;
					if (presets[Preset].alarm>89) presets[Preset].alarm=89 ;
					break;
			}
		}

		if (SwitchTime1>20  && !SwitchTime2) {
			switch (edit) {
				case 0:
					Preset--;  // 5 max
					if (Preset<0) Preset=5;
					break;

				case 1:
					presets[Preset].CA--;
					if (SwitchTime1>60) presets[Preset].CA-=2.0;
					if (presets[Preset].CA<1.0) presets[Preset].CA = 1.0;
					presets[Preset].useCA=true;
					break;


				case 2:
					presets[Preset].center--;
					if (SwitchTime1>60) presets[Preset].center-=5;
					if (presets[Preset].center<1) presets[Preset].center = 1;
					presets[Preset].useCA=false;
					break;

				case 3:
					presets[Preset].width--;
					if (SwitchTime1>60) presets[Preset].center-=5;
					if (presets[Preset].width<10) presets[Preset].width=10;
					presets[Preset].useCA=false;
					break;

				case 4:
					presets[Preset].warn--;
					if (presets[Preset].warn<0) presets[Preset].warn=0;
					break;

				case 5:
				 	presets[Preset].alarm--;
					if (presets[Preset].alarm<0) presets[Preset].alarm=0; 
					break;
			}
		}

		if (SwitchTime1  && SwitchTime2) {
			dirty=true;
			switch (edit) {
				case 0:
					presets[Preset].center = 16;
					presets[Preset].width=72;
					presets[Preset].warn=20;
				 	presets[Preset].alarm=10; 
					break;
				case 1:
					presets[Preset].center = 16;
					break;

				case 2:
					presets[Preset].width=72;
					break;

				case 3:
					presets[Preset].warn=20;
					break;

				case 4:
				 	presets[Preset].alarm=10; 
					break;
			}
			SwitchTime1=3;
			SwitchTime2=3;
		}


		if (presets[Preset].useCA) {
			CA = presets[Preset].CA;
		} else {
			slope = (float)presets[Preset].center/(float)presets[Preset].width*2.0;
			CA= 90.0 - atan(slope)*57.29578;
		}


		sprintf(Str, "Preset #%1d", (int)(Preset+1));
		WriteStr(0,70);

		sprintf(Str, "Crit.Angle =  %2.0f", CA);
		WriteStr(1,0);

		if (presets[Preset].useCA) {
			sprintf(Str, "CG Height  = ---");
			WriteStr(2,0);

			sprintf(Str, "Track Width= ---");
			WriteStr(3,0);

		} else {
			sprintf(Str, "CG Height  = %3d", presets[Preset].center);
			WriteStr(2,0);

			sprintf(Str, "Track Width= %3d", presets[Preset].width);
			WriteStr(3,0);
		}

		sprintf(Str, "Warn Angle = %3d", presets[Preset].warn);
		WriteStr(5,0);

		sprintf(Str, "Alarm Angle= %3d", presets[Preset].alarm);
		WriteStr(6,0);

		sprintf(Str, "<*>");

		switch(edit) {
			case 1:
				WriteStr(1,102);
				break;

			case 2:
				WriteStr(2,102);
				break;

			case 3:
				WriteStr(3,102);
				break;

			case 4:
				WriteStr(5,102);
				break;

			case 5:
				WriteStr(6,102);
				break;
		}


		switch(edit) {
			case 0:
				sprintf(Str, "PRESET");
				break;

			case 1:
				sprintf(Str, "Critical ANGLE");
				break;

			case 2:
				sprintf(Str, "CG HEIGHT");
				break;

			case 3:
				sprintf(Str, "TRACK WIDTH");
				break;

			case 4:
				sprintf(Str, "WARN ANGLE");
				break;

			case 5:
				sprintf(Str, "ALARM ANGLE");
				break;
		}
		WriteStr(7,20);

		sprintf(Str, "-<*>+");
		WriteStr(7,98);


		T0_Wait_ms(20);
	} else if (Display==2) {

		sprintf(Str, "Powering Off");
		WriteStr(4,12);
		
		T0_Wait_ms(20);

		if (!SW0) shutdown = true;
	} else if (Display==4) {

		if (SW0) {
			if (SwitchTime0++ > 0)  {
				Display=0;
				SwitchTime0=-2000;
			}
		} else  {
			SwitchTime0=0;
		}

		sprintf(Str, "WARNING");
		WriteStr(1,0);

		sprintf(Str,"I have read and");
		WriteStr(3,0);

		sprintf(Str, "understand the user's");
		WriteStr(4,0);

 		sprintf(Str, "manual.");
		WriteStr(5,0);

		sprintf(Str, "Agree");
		WriteStr(7,8*6);

	}


		WriteFrame();


// SMBus Accelerometer Read Sequence

		TARGET = ACCEL;             // Target the Slave for next SMBus
		SMB_DATA_OUT[0] = 0x00;		// register
		NUM_BYTES_WR = 1;
		SMB_Write();

		NUM_BYTES_RD  = 7;                                    // transfer
		SMB_Read();

		value.c[0]=SMB_DATA_IN[1];
		value.c[1]=SMB_DATA_IN[2];
		motionX[1] = abs(value.i - motionX[0]);		// previous state , difference
		motionX[0] = value.i;
		X=(float)value.i/16384.0;

		value.c[0]=SMB_DATA_IN[3];
		value.c[1]=SMB_DATA_IN[4];
		motionY[1] = abs(value.i - motionY[0]);		// previous state , difference
		motionY[0] = value.i;
		Y=(float)value.i/16384.0;

		value.c[0]=SMB_DATA_IN[5];
		value.c[1]=SMB_DATA_IN[6];
		motionZ[1] = abs(value.i - motionZ[0]);		// previous state , difference
		motionZ[0] = value.i;
		Z=(float)value.i/16384.0;

		TiltAngle += (atan(X/Y)*57.29578 - TiltAngle) * 0.1;
		if (TiltMax<abs(TiltAngle)) TiltMax = abs(TiltAngle);

		if ((Display==0) || ((loops & 0x3) == 0)) {
//		if (Display==0) {
			if ((motionX[1]<400) && (motionY[1]<400) && (motionZ[1]<400)) motionless++;
			else motionless=0;
		}



		TARGET = PHOTO;             // Target the Slave for next SMBus
		SMB_DATA_OUT[0] = 0x8C;		// register
		NUM_BYTES_WR = 1;
		SMB_Write();
		NUM_BYTES_RD = 1; 
		SMB_Read();

		if (SMB_DATA_IN[0] & 4) {  // then read data

			SMB_DATA_OUT[0] = 0x88;		// register
			NUM_BYTES_WR = 1;
			SMB_Write();
			NUM_BYTES_RD = 1; 
			SMB_Read();
			value.c[1]=SMB_DATA_IN[0];
			SMB_DATA_OUT[0] = 0x89;		// register
			NUM_BYTES_WR = 1;
			SMB_Write();
			NUM_BYTES_RD = 1; 
			SMB_Read();
			value.c[0]=SMB_DATA_IN[0];
			Photo1=value.i;	// infrared

			SMB_DATA_OUT[0] = 0x8a;		// register
			NUM_BYTES_WR = 1;
			SMB_Write();
			NUM_BYTES_RD = 1; 
			SMB_Read();
			value.c[1]=SMB_DATA_IN[0];
			SMB_DATA_OUT[0] = 0x8b;		// register
			NUM_BYTES_WR = 1;
			SMB_Write();
			NUM_BYTES_RD = 1; 
			SMB_Read();
			value.c[0]=SMB_DATA_IN[0];
			Photo0=value.i;	// visible

			PCA0CPH1=255;	// LCD brightness  Brighter for low numbers
							// led_brightness  Brighter for low numbers

			for (i=15; !(Photo0 & (1<<i)) && i; i--);  // find msb of Photo0

			led_brightness = LEDB[i];
			PCA0CPH1 = LCDB[i];


		}


// LED control states
		if (presets[Preset].useCA) {
			CA = presets[Preset].CA;
		} else {
			slope = (float)presets[Preset].center/(float)presets[Preset].width*2.0;
			CA= 90.0 - atan(slope)*57.29578;
		}

		LEDS_OFF;

		if (abs(TiltAngle) < 5.0) {
			GRNL=ON;
			GRNR=ON;
			Alarm=false;
		}
		else if (abs(TiltAngle) < CA - (float)presets[Preset].warn) {
			if (TiltAngle>0) GRNL=ON;
			else GRNR=ON;
			Alarm=false;

		} else if (abs(TiltAngle) < CA - (float)presets[Preset].alarm) {

			if (jiffies & 0x1000) {		// blink Yellow
				if (TiltAngle>0) YLWL=ON;
				else YLWR=ON;
			}
			Continuous=true;
			if (Display==0) Alarm=true;
		} else {

			if (TiltAngle>0) YLWL=ON;
			else YLWR=ON;

			if (jiffies & 0x1000) {		// blink red
				if (TiltAngle>0) REDL=ON;
				else REDR=ON;
			}
			Continuous=false;
			if (Display==0) Alarm=true;
		}

		if (Alarm) P4 &= ~0x08;		// External Alarm enable
		else P4 |= 0x08;


	if ((motionless>5000) || ((battery<280) && (bcount>5))  || (shutdown && !SW0)) {  // shutdown

		SMB_DATA_OUT[0] = 0x80;		// register
		SMB_DATA_OUT[1] = 0x01;		// active mode
		NUM_BYTES_WR =2;
		TARGET = PHOTO;             // Target the Slave for next SMBus                             // transfer
		SMB_Write();                     // Initiate SMBus write
		T0_Wait_ms(1);


		SMB_DATA_OUT[0] = 0x2a;		// register
		SMB_DATA_OUT[1] = 0xf8;		// idle mode
		SMB_DATA_OUT[2] = 0x00;
		NUM_BYTES_WR =3;
		TARGET = ACCEL;             // Target the Slave for next SMBus	                               // transfer
		SMB_Write();                     // Initiate SMBus write
		T0_Wait_ms(1);

		P1 = 0;
		LEDS_OFF;
		leds = LEDS_MASK | 0x80;  // LCD OFF
		PCA0CPM0 = 0x02;		// force low Vcont
		PCA0CPM1 = 0x02;		// force low VLEDS for LCD
		P4 = 0xBD;				// Von is low
		T0_Wait_ms(10);
		EA=0;
		CHIP_RST=1;				// no pull up but enables turn on
		P0=0;

		PCON = 2;			// suspend clock

	}

	if ((loops & 0x1)==0) { // about every 10 seconds

		ADC0CN = 0x90;  // start conversion
		while (ADC0CN & 0x10); // wait for done
		value.c[1]=ADC0L;
		value.c[0]=ADC0H;

		battery = value.i;  // 10mv / count

	}

  }  // while(1) ends here

}

